// yo sls, credits to him!! //

freeslot("sfx_djump")
sfxinfo[sfx_djump].caption = "Double Jump (Sonic R)"

----------------------------------


addHook("PlayerThink", function(player)
	if player.mo.charging == nil
		player.mo.charging = false
	end
end)


addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "table")
		if not (player.pflags & PF_THOKKED)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and not (player.powers[pw_super])
		   player.mo.state = S_PLAY_ROLL
		   S_StartSound(player.mo, sfx_djump)
	       P_SetObjectMomZ(player.mo, 14*FRACUNIT)
		   player.pflags = $ & ~PF_JUMPED
		   player.pflags = $ & ~PF_SPINNING
		   player.pflags = $1|PF_THOKKED
		end
		if not (player.pflags & PF_THOKKED)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and (player.powers[pw_super])
		   player.mo.state = S_PLAY_ROLL
		   S_StartSound(player.mo, sfx_djump)
		   P_SetObjectMomZ(player.mo, 17*FRACUNIT)
		   player.pflags = $ & ~PF_JUMPED
		   player.pflags = $ & ~PF_SPINNING
		   player.pflags = $1|PF_THOKKED
		end   
	end	
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "sonic")
	    and (P_IsObjectOnGround(player.mo))
		and (player.buttontapping)
		and player.mo.charging == false
	    and not player.weapondelay
		and not (player.powers[pw_shield])
		and not (player.powers[pw_super])
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		player.charging = true
		player.weapondelay = 10
		S_StartSound(player.mo, sfx_spndsh)
		local ghost = P_SpawnGhostMobj(player.mo) 
		ghost.scale = player.mo.scale*1
		ghost.destscale = player.mo.scale
		ghost.scalespeed = $*2
	end
	if (P_IsObjectOnGround(player.mo))
		and (player.buttontapping)
		and player.mo.charging == false
	    and not player.weapondelay
		and not (player.powers[pw_shield])
		and not (player.powers[pw_super])
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		player.charging = true
		player.weapondelay = 10
		S_StartSound(player.mo, sfx_spndsh)
		local ghost = P_SpawnGhostMobj(player.mo) 
		ghost.scale = player.mo.scale*1
		ghost.destscale = player.mo.scale
		ghost.scalespeed = $*2
	end	
end)


addHook("PlayerThink", function(player)
	if not (player.cmd.buttons & BT_CUSTOM2) 
		player.buttontappready = true
		player.buttontapping = false
	elseif player.buttontappready
		player.buttontapping = true
		player.buttontappready = false
	else
		player.buttontapping = false
	end
end)



addHook("PlayerThink", function(player)
	if (P_IsObjectOnGround(player.mo))
	and (player.buttontapping)
	and player.charging == true
	and not (player.powers[pw_super])
	and not player.weapondelay
		player.charging = false
		player.weapondelay = 10
		player.mo.state = S_PLAY_SPRING
		P_SetObjectMomZ(player.mo, 20*FRACUNIT)
		S_StartSound(player.mo, sfx_s3ka0)
		player.pflags = $ |PF_JUMPED
		player.pflags = $ & ~PF_THOKKED
	end
	if (P_IsObjectOnGround(player.mo))
	and (player.buttontapping)
	and player.charging == true
	and (player.powers[pw_super])
	and not player.weapondelay
		player.charging = false
		player.weapondelay = 10
		player.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(player.mo, 25*FRACUNIT)
		S_StartSound(player.mo, sfx_s3ka0)
		player.pflags = $ |PF_JUMPED
		player.pflags = $ & ~PF_THOKKED
    end
end)


addHook("SpinSpecial", function(player)
    if (player.mo.skin == "table")
		if (player.mo.state == S_PLAY_SPRING)
		or (player.mo.state == S_PLAY_FALL)
		and not (player.powers[pw_super])
		   S_StartSound(player.mo, sfx_spin)
		   P_SpawnThokMobj(player)
		   player.mo.state = S_PLAY_ROLL
		end
	end
end)


addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "table")
    and (player.mo.state == S_PLAY_ROLL)
        return true
    end
end)


// CUSTOMIZE SECTION START
local skin = "table" // your character here
local sound = sfx_s23c // the sound that plays when you enter speed booster mode
local sound2 = sfx_kc5b // the sound that plays when you enter speed booster mode
local runtime = 200 // how long you need to run to get your speed boost
local sbspeed = 65 // how fast the speed boost is
local hasdust = false // if this is true, you will spawn dust while boosting
local hasghost = true // if this is true, you will have a after effect while boosting
local invulframes = true // if this is true, you will have invul frames while dashing
// CUSTOMIZE SECTION END PROCCED BELOW IF YOU KNOW WHAT YOUR DOING

local function SpeedBoost_Reset(player)
	player.mo.sbruntime = 0
	player.normalspeed = skins[skin].normalspeed
	player.charflags = $1 & ~SF_RUNONWATER
	player.camerascale = skins[skin].camerascale
end

addHook("PlayerThink", function(player)
	if player.mo.sbruntime == nil
		player.mo.sbruntime = 0
	end
	if player.mo.skin == skin 
	and player.speed > player.runspeed
		player.mo.sbruntime = $ + 1
	end
	if player.mo.skin == skin 
	and player.speed < player.runspeed
	and P_IsObjectOnGround(player.mo)
	and player.mo.sbruntime > 0
		SpeedBoost_Reset(player)
	end
	if player.mo.skin == skin 
	and player.speed < player.runspeed
	and P_IsObjectOnGround(player.mo)
	and player.mo.sbruntime > runtime
		S_StartSound(player.mo, sound2)
		SpeedBoost_Reset(player)
	end
	if player.mo.skin == skin 
	and player.mo.sbruntime == runtime
		S_StartSound(player.mo, sound)
	end
	if player.mo.skin == skin 
	and player.mo.sbruntime > runtime
		player.charflags = $1|SF_RUNONWATER
		player.normalspeed = sbspeed*FRACUNIT
		player.camerascale = skins[skin].camerascale*2
		if invulframes == true
			player.powers[pw_invulnerability] = TICRATE / 2
		end
		if hasdust == true and P_IsObjectOnGround(player.mo)
			P_SpawnSkidDust(player, player.mo.radius, true)
		end
		if hasghost == true
			local speedtrail = P_SpawnGhostMobj(player.mo) 
			speedtrail.colorized = true
			speedtrail.color = SKINCOLOR_AETHER
			speedtrail.fuse = 5
			speedtrail.blendmode = AST_ADD 
		end
	end
end)

